#ifndef	PSPTALK_H
#define	PSPTALK_H
/*
 * Written by Oron Peled <oron@actcom.co.il>
 * Copyright (C) 2009, Xorcom
 *
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

/*
 * PSPTALK - Power-Supply-Protocol:
 *	     A dialect of XTALK to manage Xorcom external power supplies.
 */

#include <stdint.h>
#include <xtalk/proto.h>
/* Definitions common to the firmware (in include/ directory) */
#include <psptalk_defs.h>

struct psp_device;

/* API */
struct psp_device *psp_new(struct xusb_iface *iface);
void psp_delete(struct psp_device *pspdev);

int psp_led(struct psp_device *pspdev, uint8_t bitmask);
int psp_hub_stat(struct psp_device *pspdev);
int psp_refresh_volts(struct psp_device *pspdev);
int psp_voltage(struct psp_device *pspdev, uint8_t ps_num);
int psp_set_mask(struct psp_device *pspdev, uint8_t ps_mask, uint8_t hub_mask);
int psp_get_mask(struct psp_device *pspdev);
int psp_update_mask(struct psp_device *pspdev);
int psp_ps_mask(struct psp_device *pspdev);
int psp_hub_mask(struct psp_device *pspdev);
int psp_tws_port_set(struct psp_device *pspdev, int port);
int psp_tws_port_get(struct psp_device *pspdev);
int psp_tws_pwr_get(struct psp_device *pspdev);
int psp_tws_mode_set(struct psp_device *pspdev, int enable);
int psp_tws_mode_get(struct psp_device *pspdev);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	/* PSPTALK_H */
